/*------------------------------------------------------------------------------
PrintBar.c

Source-Code der PrintBar-Funktion.
Copyright (c) 2008 OnlyWork.
All rights reserved.
------------------------------------------------------------------------------*/

/*	Zeichnet ein Fortschritts-Balken in eine 
	OSD kompatible Zeichenfolge. */
char *PrintBar(char *buffer, long int value, long int max_value, char digits)
{
	// Decoder-Tabelle
	const char barCode[] = {0xF2,0xF1,0xF0,0xEF,0xEE};

	// Aktuelle Position berechnen
	int dg = 5 * digits * value / max_value;

	// Erstes und letztes Digit setzen
	buffer[0] = 0xED;
	buffer[digits + 1] = 0xF3;

	// Alle Digits berechnen
	while (digits > 0)
	{
		// Digit setzen
		buffer[digits] = barCode[(dg/5)>=digits ? 4 : ((dg/5==(digits-1)) * (dg % 5))];
		// Nchstes Digit
		digits --;
	}

	// Zurckgeben
	return buffer;
}
